#ifndef MasterMind_CCA_H
#define MasterMind_CCA_H

#include "cca.h"
#include "ports/Monitor_CCA.h"
#include "ports/Measurement_CCA.h"
#include <map>
#include "Record_CCA.h"
#include "CallPathNode.h"

namespace monitor
{
  namespace ccaimpl
  {
    /**
     * The MasterMind class
     */
    class MasterMind: 
      public virtual monitor::ccaports::Monitor,
      public virtual classic::gov::cca::Component
    {
    public:
      MasterMind ();
      ~MasterMind ();
      virtual void createRecord(string rname);
      virtual void startMonitoring(string rname, map<string, double> &m);
      virtual void stopMonitoring(string rname);
      virtual void setFileName(string rname, string fname);
      virtual void dumpData(string rname);
      virtual void dumpData(string rnmae, string fname);
      virtual void destroyRecord(string rname);
      virtual void setServices (classic::gov::cca::Services * services);

    private:
      bool init_mport;
      bool init_tree;
      classic::gov::cca::Services * frameworkServices;
      performance::ccaports::Measurement * measurement_m;
      map<string, performance::Record*> records;
      CallPathNode * call_path_tree;
    };
  }
}
#endif                          // MasterMind_CCA_H
